"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const t = __importStar(require("@umijs/bundler-utils/compiled/babel/types"));
exports.default = () => {
    return {
        visitor: {
            Program: {
                enter(path, { opts }) {
                    const expressions = path.get('body');
                    const exports = (opts === null || opts === void 0 ? void 0 : opts.exports) || [];
                    expressions.forEach((exp) => {
                        if (!(t.isExportNamedDeclaration(exp) ||
                            t.isExportDefaultDeclaration(exp)))
                            return;
                        handleExportsIndividual(exp);
                        handleExportsList(exp);
                        handleExportsDefault(exp);
                    });
                    function handleExportsIndividual(path) {
                        if (!path.node)
                            return;
                        if (!t.isExportNamedDeclaration(path))
                            return;
                        if (!path.get('declaration').node)
                            return;
                        const declaration = path.get('declaration');
                        if (t.isVariableDeclaration(declaration)) {
                            const variables = declaration.get('declarations');
                            variables.forEach((variable) => {
                                exports.includes(variable.get('id.name').node) &&
                                    variable.remove();
                            });
                        }
                        else {
                            exports.includes(declaration.get('id.name').node) &&
                                declaration.remove();
                        }
                    }
                    function handleExportsList(path) {
                        if (!path.node)
                            return;
                        if (!t.isExportNamedDeclaration(path))
                            return;
                        const specifiers = path.get('specifiers');
                        if (!specifiers || specifiers.length === 0)
                            return;
                        specifiers.forEach((specifier) => {
                            if (exports.includes(specifier.get('exported.name').node))
                                specifier.remove();
                        });
                        if (path.get('specifiers').length === 0)
                            path.remove();
                    }
                    function handleExportsDefault(path) {
                        if (!path.node)
                            return;
                        if (!t.isExportDefaultDeclaration(path))
                            return;
                        const declaration = path.get('declaration');
                        if (!declaration.node)
                            return;
                        if (exports.includes(declaration.get('name').node))
                            declaration.remove();
                    }
                },
                exit(path) {
                    // Manually reprocess the scope to ensure that the removed declarations are updated.
                    path.scope.crawl();
                    const expressions = path.get('body');
                    expressions.forEach((exp) => {
                        if (!t.isImportDeclaration(exp))
                            return;
                        const specifiers = exp.get('specifiers');
                        specifiers.forEach((s) => {
                            const name = s.get('local.name').node;
                            if (!s.scope.getBinding(name).referenced)
                                s.remove();
                        });
                        if (exp.get('specifiers').length === 0)
                            exp.remove();
                    });
                },
            },
        },
    };
};
